// gotta go faster //	

freeslot(
"sfx_mach1",
"sfx_mach2",
"sfx_mach3",
"sfx_mach4"
)

local TOPSPEED = 120*FRACUNIT -- Cap speed for dashmode.
local RUNTIME = 20*FRACUNIT -- How long do you have to run for to activate dashmode.
local DEFNORMALSPEED = 39*FRACUNIT -- Put your default normal speed here.
local OVERRIDESPEED = 85*FRACUNIT -- Automaticly activates dashmode at a certain speed.
local MAXJUMPHIGHT = 1*FRACUNIT -- Maximum jump power when in dashmode.
local SKIN = "sonic" -- Your character's skin name goes here.

local function ResetVars(player)
player.runtime = 0
player.normalspeed = DEFNORMALSPEED
player.fakenormalspeed = DEFNORMALSPEED
player.jumpfactor = 1*FRACUNIT
end

addHook("PlayerThink", function(player)
	if player.mo.skin == SKIN then
		
		if player.fakenormalspeed == nil then player.fakenormalspeed = DEFNORMALSPEED return end
		
		if player.fakenormalspeed < TOPSPEED and player.speeddash == true and player.isxmomentum and P_IsObjectOnGround(player.mo)
			player.fakenormalspeed = $1 + 2*FRACUNIT/5  
		end
		if player.normalspeed < TOPSPEED and player.speeddash == true and not player.isxmomentum and P_IsObjectOnGround(player.mo)
			player.normalspeed = $1 + 2*FRACUNIT/5 
		end
		if player.jumpfactor < MAXJUMPHIGHT and player.speeddash == true
			player.jumpfactor = $1 + 1*FRACUNIT/100
		end
		if player.speed > 27*FRACUNIT and not (leveltime % 5) and P_IsObjectOnGround(player.mo)
		if player.runtime == nil then player.runtime = 0 return true end
			player.runtime = $ + 1*FRACUNIT
		end
		if player.speed < 27*FRACUNIT and P_IsObjectOnGround(player.mo) or P_PlayerInPain(player)
			if player.speeddash == true and not then
			S_StartSound(player.mo, sfx_kc65)
			player.speeddash = false
			end
			ResetVars(player)
		end
		if player.speeddash == true
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.fuse = 2
			player.charflags = $1|SF_RUNONWATER
		else
			player.charflags = $1 & ~SF_RUNONWATER
		end
		if player.speeddash == true and P_IsObjectOnGround(player.mo) then
			P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none) -- Spawns rundust
		end
		if not player.speeddash == true and P_IsObjectOnGround(player.mo) and player.runtime >= 10*FRACUNIT then
			P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none) -- Spawns rundust
		end
		if player.speed >= 70*FRACUNIT and player.speeddash == true and P_IsObjectOnGround(player.mo) then
			P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none) -- Spawns rundust
			P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none) -- Spawns rundust
			P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none) -- Spawns rundust
		end
		local skin = skins[player.mo.skin]
		if player.speed >= 60*FRACUNIT then
			player.camerascale = skin.camerascale*5/4
		elseif player.speed >= 80*FRACUNIT then
			player.camerascale = skin.camerascale*9/8
		else
			player.camerascale = skin.camerascale
		end
		if P_IsObjectOnGround(player.mo) 
		and player.runtime >= 10*FRACUNIT and player.speed <= 54*FRACUNIT and player.speed >= 27*FRACUNIT 
			if not S_SoundPlaying(player.mo, sfx_mach1)
			S_StartSound(player.mo, sfx_mach1)-- Plays the sounds
			end
		else
		S_StopSoundByID(player.mo, sfx_mach1) -- Stops the sound when reqierments are not reached.
		end
		if player.speeddash == true and P_IsObjectOnGround(player.mo) and player.speed <= 79*FRACUNIT and player.speed >= 55*FRACUNIT
			if not S_SoundPlaying(player.mo, sfx_mach2)
			S_StartSound(player.mo, sfx_mach2)
			end
		else
		S_StopSoundByID(player.mo, sfx_mach2)
		end
		if player.speeddash == true and P_IsObjectOnGround(player.mo) and player.speed >= 80*FRACUNIT and player.speed < 100*FRACUNIT
			if not S_SoundPlaying(player.mo, sfx_mach3)
			S_StartSound(player.mo, sfx_mach3)
			end
		else
		S_StopSoundByID(player.mo, sfx_mach3)
		end
		if player.speeddash == true and P_IsObjectOnGround(player.mo) and player.speed >= 100*FRACUNIT
			if not S_SoundPlaying(player.mo, sfx_mach4)
			S_StartSound(player.mo, sfx_mach4)
			end
		else
		S_StopSoundByID(player.mo, sfx_mach4)
		end
		if player.speeddash == true and P_IsObjectOnGround(player.mo)
		PizzaTowerAfterImages(player, player.mo, player.ptaicolor)
			if not player.ptaiframewait
				player.ptaiframewait = 3
					if player.ptaicolor == 1
						player.ptaicolor = 2
					else
						player.ptaicolor = 1
					end
				else
				player.ptaiframewait = $ -1
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.skin == SKIN then
		if player.runtime == nil then player.runtime = 0 return true end
		if not player.speeddash == true
		and player.runtime >= RUNTIME
		and P_IsObjectOnGround(player.mo)
			S_StartSound(player.mo, sfx_s3ka2)
			player.speeddash = true
			if not player.xmomentum
			player.normalspeed = player.speed
			else
			player.fakenormalspeed = player.speed
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.skin == SKIN then
		if player.runtime == nil then player.runtime = 0 return true end
		if not player.speeddash == true
		and player.speed >= OVERRIDESPEED
			S_StartSound(player.mo, sfx_s3ka2)
			player.speeddash = true
			if not player.xmomentum
			player.normalspeed = player.speed
			else
			player.fakenormalspeed = player.speed
			end
		end
	end
end)

addHook("MobjMoveCollide", function(mo, spike) -- Spike breaking by ARJr.
    if mo.valid
    and (mo.type == MT_PLAYER)
	and mo.player.speed > 75*FRACUNIT
    and spike.type == MT_SPIKE
		if (spike.z >= (mo.z - 16*FRACUNIT)) and (spike.z <= (mo.z + mo.height + 16*FRACUNIT))
			P_KillMobj(spike, mo, mo)
		elseif (spike.flags2 & MF2_OBJECTFLIP)
		and (spike.z <= (mo.z - 16*FRACUNIT)) and (spike.z >= (mo.z + mo.height+ 16*FRACUNIT))
			P_KillMobj(spike, mo, mo)
        end
    end
end)
